Subject: bug#57957: 29.0.50; Native compilation hangs on cyclic lists

From: Stefan Monnier <[email-masked]>
Date: Thu, 22 Sep 2022 13:10:09 -0400

> The question is of course also how much effort circular lists deserve in
> the compiler.  From my point of view, not too much because they aren't
> very useful, in code at least.  And dealing with them costs runtime.

Circular data structures are perfectly normal in source code under
a `quote` but the code itself should never be cyclic (so I think it
would be OK to signal an error (and/or to inf-loop) when asked to
compile a chunk of code that has a cycle).  So we *should* handle
circular data structures correctly.

Note: I don't know why we'd need/want to do a `subst-if` inside
a `quote` and haven't looked at this bug or at the `comp.el` code to
know what we're really talking about.

        Stefan